Attribute VB_Name = "modWin32"
Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&
Public Const E_NOINTERFACE As Long = &H80004002
Public Const IID_IUnknown As String = "{00000000-0000-0000-c000-000000000046}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    IUnknown_Release = 2

End Enum

' ----==== Types ====----
Public Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type
                
' ----==== Ole32.dll Declarations ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "Ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long
                         
' ----==== Oleaut32.dll Declarations ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

' ----==== Combase.dll Declarations ====----
Private Declare Function RoGetActivationFactory Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef riid As GUID, _
                         ByRef factory As Long) As Long

Private Declare Function WindowsCreateString Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByVal lenght As Long, _
                         ByRef hString As Long) As Long

Private Declare Function WindowsDeleteString Lib "Combase.dll" ( _
                         ByVal sourceString As Long) As Long
                         
' ----==== WinRT Functions ====----
Public Function GetActivationFactory(ByVal ClassName As String, _
                                     ByVal iid As String, _
                                     ByRef pFactory As Long) As Boolean
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            If RoGetActivationFactory(hString, Str2Guid(iid), pFactory) = S_OK Then
                GetActivationFactory = True
            End If
            Call WindowsDeleteString(hString)
        End If
    End If
End Function

' ----==== Interface Functions ====----
Public Sub ReleaseIfc(ByRef pInterface As Long)
    If pInterface <> 0& Then
        Call InvokeIfc(pInterface, _
                       IUnknown_Release)
        pInterface = 0&
    End If
End Sub

Private Function InvokeIfc(ByVal pInterface As Long, _
                           ByVal vtb As vtb_Interfaces, _
                           ParamArray var()) As Variant
    If pInterface <> 0& Then
        InvokeIfc = OleInvoke(pInterface, vtb, var)
    End If
End Function

Public Function OleInvoke(ByVal pInterface As Long, _
                          ByVal lngCmd As Long, _
                          ParamArray aParam()) As Variant
    If pInterface <> 0& Then
        If UBound(aParam) >= 0& Then
            Dim varParam As Variant
            varParam = aParam
            If IsArray(varParam) Then varParam = varParam(0)
            Dim lngCount As Long
            lngCount = UBound(varParam)
            Dim lngItem As Long
            Dim olePtr(10) As Long
            Dim oleTyp(10) As Integer
            For lngItem = 0& To lngCount
                oleTyp(lngItem) = VarType(varParam(lngItem))
                olePtr(lngItem) = VarPtr(varParam(lngItem))
            Next
        End If
        Dim varRet As Variant
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, _
                        vbLong, lngItem, VarPtr(oleTyp(0)), _
                        VarPtr(olePtr(0)), varRet) <> S_OK Then
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
        End If

'        If varRet <> S_OK Then
'            Debug.Print "0x" & Hex$(varRet)
'        End If
    End If
    OleInvoke = varRet
End Function

' ----==== Helper Functions ====----
Public Function ProcPtr(ByVal ptr As Long) As Long
    ProcPtr = ptr
End Function

Private Function Str2Guid(ByVal strGUID As String) As GUID
    If Len(strGUID) = 38 Then
        Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
    End If
End Function

Public Function Guid2Str(ByRef tGUID As GUID) As String
    Dim lngRet As Long
    Dim strGUID As String
    strGUID = String(40, 0)
    lngRet = StringFromGUID(tGUID, StrPtr(strGUID), Len(strGUID))
    If lngRet > 0& Then
        Guid2Str = Left$(strGUID, lngRet - 1)
    Else
        Guid2Str = vbNullString
    End If
End Function

